Index: palm/trunk/SOURCE/surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_mod.f90	(revision 4501)
+++ palm/trunk/SOURCE/surface_mod.f90	(revision 4502)
@@ -4417,341 +4648,389 @@
              horizontal_surface = .FALSE.
              vertical_surface   = .TRUE.
-          CASE ( 'surf_v(0)%end_index' )   
+          CASE ( 'surf_v(0)%end_index' )
              IF ( kk == 1 )                                                    &
                 READ ( 13 )  surf_v(0)%end_index
-          CASE ( 'surf_v(0)%us' )         
+          CASE ( 'surf_v(0)%us' )
              IF ( ALLOCATED( surf_v(0)%us )  .AND.  kk == 1 )                  &
                 READ ( 13 )  surf_v(0)%us
-          CASE ( 'surf_v(0)%ts' )         
+          CASE ( 'surf_v(0)%ts' )
              IF ( ALLOCATED( surf_v(0)%ts )  .AND.  kk == 1 )                  &
                 READ ( 13 )  surf_v(0)%ts
-          CASE ( 'surf_v(0)%qs' )         
+          CASE ( 'surf_v(0)%qs' )
              IF ( ALLOCATED( surf_v(0)%qs )  .AND.  kk == 1 )                  &
                 READ ( 13 )  surf_v(0)%qs
-          CASE ( 'surf_v(0)%ss' )         
+          CASE ( 'surf_v(0)%ss' )
              IF ( ALLOCATED( surf_v(0)%ss )  .AND.  kk == 1 )                  &
                 READ ( 13 )  surf_v(0)%ss
-          CASE ( 'surf_v(0)%qcs' )         
+          CASE ( 'surf_v(0)%qcs' )
              IF ( ALLOCATED( surf_v(0)%qcs )  .AND.  kk == 1 )                 &
                 READ ( 13 )  surf_v(0)%qcs
-          CASE ( 'surf_v(0)%ncs' )         
+          CASE ( 'surf_v(0)%ncs' )
              IF ( ALLOCATED( surf_v(0)%ncs )  .AND.  kk == 1 )                 &
                 READ ( 13 )  surf_v(0)%ncs
-          CASE ( 'surf_v(0)%qrs' )         
+          CASE ( 'surf_v(0)%qis' )
+             IF ( ALLOCATED( surf_v(0)%qis )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_v(0)%qis
+          CASE ( 'surf_v(0)%nis' )
+             IF ( ALLOCATED( surf_v(0)%nis )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_v(0)%nis
+          CASE ( 'surf_v(0)%qrs' )
              IF ( ALLOCATED( surf_v(0)%qrs )  .AND.  kk == 1 )                 &
                 READ ( 13 )  surf_v(0)%qrs
-          CASE ( 'surf_v(0)%nrs' )         
+          CASE ( 'surf_v(0)%nrs' )
              IF ( ALLOCATED( surf_v(0)%nrs )  .AND.  kk == 1 )                 &
                 READ ( 13 )  surf_v(0)%nrs
-          CASE ( 'surf_v(0)%ol' )         
+          CASE ( 'surf_v(0)%ol' )
              IF ( ALLOCATED( surf_v(0)%ol )  .AND.  kk == 1 )                  &
                 READ ( 13 )  surf_v(0)%ol
-          CASE ( 'surf_v(0)%rib' )         
+          CASE ( 'surf_v(0)%rib' )
              IF ( ALLOCATED( surf_v(0)%rib )  .AND.  kk == 1 )                 &
                 READ ( 13 )  surf_v(0)%rib
-          CASE ( 'surf_v(0)%pt_surface' )         
+          CASE ( 'surf_v(0)%pt_surface' )
              IF ( ALLOCATED( surf_v(0)%pt_surface )  .AND.  kk == 1 )          &
                 READ ( 13 )  surf_v(0)%pt_surface
-          CASE ( 'surf_v(0)%q_surface' )         
+          CASE ( 'surf_v(0)%q_surface' )
              IF ( ALLOCATED( surf_v(0)%q_surface )  .AND.  kk == 1 )           &
                 READ ( 13 )  surf_v(0)%q_surface
-          CASE ( 'surf_v(0)%vpt_surface' )         
+          CASE ( 'surf_v(0)%vpt_surface' )
              IF ( ALLOCATED( surf_v(0)%vpt_surface )  .AND.  kk == 1 )         &
                 READ ( 13 )  surf_v(0)%vpt_surface
-          CASE ( 'surf_v(0)%shf' )         
+          CASE ( 'surf_v(0)%shf' )
              IF ( ALLOCATED( surf_v(0)%shf )  .AND.  kk == 1 )                 &
                 READ ( 13 )  surf_v(0)%shf
-          CASE ( 'surf_v(0)%qsws' )         
+          CASE ( 'surf_v(0)%qsws' )
              IF ( ALLOCATED( surf_v(0)%qsws )  .AND.  kk == 1 )                &
                 READ ( 13 )  surf_v(0)%qsws
-          CASE ( 'surf_v(0)%ssws' )         
+          CASE ( 'surf_v(0)%ssws' )
              IF ( ALLOCATED( surf_v(0)%ssws )  .AND.  kk == 1 )                &
                 READ ( 13 )  surf_v(0)%ssws
-          CASE ( 'surf_v(0)%css' ) 
+          CASE ( 'surf_v(0)%css' )
              IF ( ALLOCATED( surf_v(0)%css )  .AND.  kk == 1 )                 &
                 READ ( 13 )  surf_v(0)%css
-          CASE ( 'surf_v(0)%cssws' )         
+          CASE ( 'surf_v(0)%cssws' )
              IF ( ALLOCATED( surf_v(0)%cssws )  .AND.  kk == 1 )               &
                 READ ( 13 )  surf_v(0)%cssws
-          CASE ( 'surf_v(0)%qcsws' )         
+          CASE ( 'surf_v(0)%qcsws' )
              IF ( ALLOCATED( surf_v(0)%qcsws )  .AND.  kk == 1 )               &
                 READ ( 13 )  surf_v(0)%qcsws
-          CASE ( 'surf_v(0)%ncsws' )         
+          CASE ( 'surf_v(0)%ncsws' )
              IF ( ALLOCATED( surf_v(0)%ncsws )  .AND.  kk == 1 )               &
                 READ ( 13 )  surf_v(0)%ncsws
-          CASE ( 'surf_v(0)%qrsws' )         
+          CASE ( 'surf_v(0)%qisws' )
+             IF ( ALLOCATED( surf_v(0)%qisws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_v(0)%qisws
+          CASE ( 'surf_v(0)%nisws' )
+             IF ( ALLOCATED( surf_v(0)%nisws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_v(0)%nisws
+          CASE ( 'surf_v(0)%qrsws' )
              IF ( ALLOCATED( surf_v(0)%qrsws )  .AND.  kk == 1 )               &
                 READ ( 13 )  surf_v(0)%qrsws
-          CASE ( 'surf_v(0)%nrsws' )         
+          CASE ( 'surf_v(0)%nrsws' )
              IF ( ALLOCATED( surf_v(0)%nrsws )  .AND.  kk == 1 )               &
                 READ ( 13 )  surf_v(0)%nrsws
-          CASE ( 'surf_v(0)%sasws' )         
+          CASE ( 'surf_v(0)%sasws' )
              IF ( ALLOCATED( surf_v(0)%sasws )  .AND.  kk == 1 )               &
                 READ ( 13 )  surf_v(0)%sasws
-          CASE ( 'surf_v(0)%mom_uv' )         
+          CASE ( 'surf_v(0)%mom_uv' )
              IF ( ALLOCATED( surf_v(0)%mom_flux_uv )  .AND.  kk == 1 )         &
                 READ ( 13 )  surf_v(0)%mom_flux_uv
-          CASE ( 'surf_v(0)%mom_w' )         
+          CASE ( 'surf_v(0)%mom_w' )
              IF ( ALLOCATED( surf_v(0)%mom_flux_w )  .AND.  kk == 1 )          &
                 READ ( 13 )  surf_v(0)%mom_flux_w
-          CASE ( 'surf_v(0)%mom_tke' )         
+          CASE ( 'surf_v(0)%mom_tke' )
              IF ( ALLOCATED( surf_v(0)%mom_flux_tke )  .AND.  kk == 1 )        &
                 READ ( 13 )  surf_v(0)%mom_flux_tke
 
-          CASE ( 'surf_v(1)%start_index' )   
+          CASE ( 'surf_v(1)%start_index' )
              IF ( kk == 1 )                                                    &
                 READ ( 13 )  surf_v(1)%start_index
              l = 1
-          CASE ( 'surf_v(1)%end_index' )   
+          CASE ( 'surf_v(1)%end_index' )
              IF ( kk == 1 )                                                    &
                 READ ( 13 )  surf_v(1)%end_index
-          CASE ( 'surf_v(1)%us' )         
+          CASE ( 'surf_v(1)%us' )
              IF ( ALLOCATED( surf_v(1)%us )  .AND.  kk == 1 )                  &
                 READ ( 13 )  surf_v(1)%us
-          CASE ( 'surf_v(1)%ts' )         
+          CASE ( 'surf_v(1)%ts' )
              IF ( ALLOCATED( surf_v(1)%ts )  .AND.  kk == 1 )                  &
                 READ ( 13 )  surf_v(1)%ts
-          CASE ( 'surf_v(1)%qs' )         
+          CASE ( 'surf_v(1)%qs' )
              IF ( ALLOCATED( surf_v(1)%qs )  .AND.  kk == 1 )                  &
                 READ ( 13 )  surf_v(1)%qs
-          CASE ( 'surf_v(1)%ss' )         
+          CASE ( 'surf_v(1)%ss' )
              IF ( ALLOCATED( surf_v(1)%ss )  .AND.  kk == 1 )                  &
                 READ ( 13 )  surf_v(1)%ss
-          CASE ( 'surf_v(1)%qcs' )         
+          CASE ( 'surf_v(1)%qcs' )
              IF ( ALLOCATED( surf_v(1)%qcs )  .AND.  kk == 1 )                 &
                 READ ( 13 )  surf_v(1)%qcs
-          CASE ( 'surf_v(1)%ncs' )         
+          CASE ( 'surf_v(1)%ncs' )
              IF ( ALLOCATED( surf_v(1)%ncs )  .AND.  kk == 1 )                 &
                 READ ( 13 )  surf_v(1)%ncs
-          CASE ( 'surf_v(1)%qrs' )         
+          CASE ( 'surf_v(1)%qis' )
+             IF ( ALLOCATED( surf_v(1)%qis )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_v(1)%qis
+          CASE ( 'surf_v(1)%nis' )
+             IF ( ALLOCATED( surf_v(1)%nis )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_v(1)%nis
+          CASE ( 'surf_v(1)%qrs' )
              IF ( ALLOCATED( surf_v(1)%qrs )  .AND.  kk == 1 )                 &
                 READ ( 13 )  surf_v(1)%qrs
-          CASE ( 'surf_v(1)%nrs' )         
+          CASE ( 'surf_v(1)%nrs' )
              IF ( ALLOCATED( surf_v(1)%nrs )  .AND.  kk == 1 )                 &
                 READ ( 13 )  surf_v(1)%nrs
-          CASE ( 'surf_v(1)%ol' )         
+          CASE ( 'surf_v(1)%ol' )
              IF ( ALLOCATED( surf_v(1)%ol )  .AND.  kk == 1 )                  &
                 READ ( 13 )  surf_v(1)%ol
-          CASE ( 'surf_v(1)%rib' )         
+          CASE ( 'surf_v(1)%rib' )
              IF ( ALLOCATED( surf_v(1)%rib )  .AND.  kk == 1 )                 &
                 READ ( 13 )  surf_v(1)%rib
-          CASE ( 'surf_v(1)%pt_surface' )         
+          CASE ( 'surf_v(1)%pt_surface' )
              IF ( ALLOCATED( surf_v(1)%pt_surface )  .AND.  kk == 1 )          &
                 READ ( 13 )  surf_v(1)%pt_surface
-          CASE ( 'surf_v(1)%q_surface' )         
+          CASE ( 'surf_v(1)%q_surface' )
              IF ( ALLOCATED( surf_v(1)%q_surface )  .AND.  kk == 1 )           &
                 READ ( 13 )  surf_v(1)%q_surface
-          CASE ( 'surf_v(1)%vpt_surface' )         
+          CASE ( 'surf_v(1)%vpt_surface' )
              IF ( ALLOCATED( surf_v(1)%vpt_surface )  .AND.  kk == 1 )         &
                 READ ( 13 )  surf_v(1)%vpt_surface
-          CASE ( 'surf_v(1)%shf' )         
+          CASE ( 'surf_v(1)%shf' )
              IF ( ALLOCATED( surf_v(1)%shf )  .AND.  kk == 1 )                 &
                 READ ( 13 )  surf_v(1)%shf
-          CASE ( 'surf_v(1)%qsws' )         
+          CASE ( 'surf_v(1)%qsws' )
              IF ( ALLOCATED( surf_v(1)%qsws )  .AND.  kk == 1 )                &
                 READ ( 13 )  surf_v(1)%qsws
-          CASE ( 'surf_v(1)%ssws' )         
+          CASE ( 'surf_v(1)%ssws' )
              IF ( ALLOCATED( surf_v(1)%ssws )  .AND.  kk == 1 )                &
                 READ ( 13 )  surf_v(1)%ssws
-          CASE ( 'surf_v(1)%css' ) 
+          CASE ( 'surf_v(1)%css' )
              IF ( ALLOCATED( surf_v(1)%css )  .AND.  kk == 1 )                 &
                 READ ( 13 )  surf_v(1)%css
-          CASE ( 'surf_v(1)%cssws' )         
+          CASE ( 'surf_v(1)%cssws' )
              IF ( ALLOCATED( surf_v(1)%cssws )  .AND.  kk == 1 )               &
                 READ ( 13 )  surf_v(1)%cssws
-          CASE ( 'surf_v(1)%qcsws' )         
+          CASE ( 'surf_v(1)%qcsws' )
              IF ( ALLOCATED( surf_v(1)%qcsws )  .AND.  kk == 1 )               &
                 READ ( 13 )  surf_v(1)%qcsws
-          CASE ( 'surf_v(1)%ncsws' )         
+          CASE ( 'surf_v(1)%ncsws' )
              IF ( ALLOCATED( surf_v(1)%ncsws )  .AND.  kk == 1 )               &
                 READ ( 13 )  surf_v(1)%ncsws
-          CASE ( 'surf_v(1)%qrsws' )         
+          CASE ( 'surf_v(1)%qisws' )
+             IF ( ALLOCATED( surf_v(1)%qisws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_v(1)%qisws
+          CASE ( 'surf_v(1)%nisws' )
+             IF ( ALLOCATED( surf_v(1)%nisws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_v(1)%nisws
+          CASE ( 'surf_v(1)%qrsws' )
              IF ( ALLOCATED( surf_v(1)%qrsws )  .AND.  kk == 1 )               &
                 READ ( 13 )  surf_v(1)%qrsws
-          CASE ( 'surf_v(1)%nrsws' )         
+          CASE ( 'surf_v(1)%nrsws' )
              IF ( ALLOCATED( surf_v(1)%nrsws )  .AND.  kk == 1 )               &
                 READ ( 13 )  surf_v(1)%nrsws
-          CASE ( 'surf_v(1)%sasws' )         
+          CASE ( 'surf_v(1)%sasws' )
              IF ( ALLOCATED( surf_v(1)%sasws )  .AND.  kk == 1 )               &
                 READ ( 13 )  surf_v(1)%sasws
-          CASE ( 'surf_v(1)%mom_uv' )         
+          CASE ( 'surf_v(1)%mom_uv' )
              IF ( ALLOCATED( surf_v(1)%mom_flux_uv )  .AND.  kk == 1 )         &
                 READ ( 13 )  surf_v(1)%mom_flux_uv
-          CASE ( 'surf_v(1)%mom_w' )         
+          CASE ( 'surf_v(1)%mom_w' )
              IF ( ALLOCATED( surf_v(1)%mom_flux_w )  .AND.  kk == 1 )          &
                 READ ( 13 )  surf_v(1)%mom_flux_w
-          CASE ( 'surf_v(1)%mom_tke' )         
+          CASE ( 'surf_v(1)%mom_tke' )
              IF ( ALLOCATED( surf_v(1)%mom_flux_tke )  .AND.  kk == 1 )        &
                 READ ( 13 )  surf_v(1)%mom_flux_tke
 
-          CASE ( 'surf_v(2)%start_index' )   
+          CASE ( 'surf_v(2)%start_index' )
              IF ( kk == 1 )                                                    &
                 READ ( 13 )  surf_v(2)%start_index
              l = 2
-          CASE ( 'surf_v(2)%end_index' )   
+          CASE ( 'surf_v(2)%end_index' )
              IF ( kk == 1 )                                                    &
                 READ ( 13 )  surf_v(2)%end_index
-          CASE ( 'surf_v(2)%us' )         
+          CASE ( 'surf_v(2)%us' )
              IF ( ALLOCATED( surf_v(2)%us )  .AND.  kk == 1 )                  &
                 READ ( 13 )  surf_v(2)%us
-          CASE ( 'surf_v(2)%ts' )         
+          CASE ( 'surf_v(2)%ts' )
              IF ( ALLOCATED( surf_v(2)%ts )  .AND.  kk == 1 )                  &
                 READ ( 13 )  surf_v(2)%ts
-          CASE ( 'surf_v(2)%qs' )         
+          CASE ( 'surf_v(2)%qs' )
              IF ( ALLOCATED( surf_v(2)%qs )  .AND.  kk == 1 )                  &
                 READ ( 13 )  surf_v(2)%qs
-          CASE ( 'surf_v(2)%ss' )         
+          CASE ( 'surf_v(2)%ss' )
              IF ( ALLOCATED( surf_v(2)%ss )  .AND.  kk == 1 )                  &
                 READ ( 13 )  surf_v(2)%ss
-          CASE ( 'surf_v(2)%qcs' )         
+          CASE ( 'surf_v(2)%qcs' )
              IF ( ALLOCATED( surf_v(2)%qcs )  .AND.  kk == 1 )                 &
                 READ ( 13 )  surf_v(2)%qcs
-          CASE ( 'surf_v(2)%ncs' )         
+          CASE ( 'surf_v(2)%ncs' )
              IF ( ALLOCATED( surf_v(2)%ncs )  .AND.  kk == 1 )                 &
                 READ ( 13 )  surf_v(2)%ncs
-          CASE ( 'surf_v(2)%qrs' )         
+          CASE ( 'surf_v(2)%qis' )
+             IF ( ALLOCATED( surf_v(2)%qis )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_v(2)%qis
+          CASE ( 'surf_v(2)%nis' )
+             IF ( ALLOCATED( surf_v(2)%nis )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_v(2)%nis
+          CASE ( 'surf_v(2)%qrs' )
              IF ( ALLOCATED( surf_v(2)%qrs )  .AND.  kk == 1 )                 &
                 READ ( 13 )  surf_v(2)%qrs
-          CASE ( 'surf_v(2)%nrs' )         
+          CASE ( 'surf_v(2)%nrs' )
              IF ( ALLOCATED( surf_v(2)%nrs )  .AND.  kk == 1 )                 &
                 READ ( 13 )  surf_v(2)%nrs
-          CASE ( 'surf_v(2)%ol' )         
+          CASE ( 'surf_v(2)%ol' )
              IF ( ALLOCATED( surf_v(2)%ol )  .AND.  kk == 1 )                  &
                 READ ( 13 )  surf_v(2)%ol
-          CASE ( 'surf_v(2)%rib' )         
+          CASE ( 'surf_v(2)%rib' )
              IF ( ALLOCATED( surf_v(2)%rib )  .AND.  kk == 1 )                 &
                 READ ( 13 )  surf_v(2)%rib
-          CASE ( 'surf_v(2)%pt_surface' )         
+          CASE ( 'surf_v(2)%pt_surface' )
              IF ( ALLOCATED( surf_v(2)%pt_surface )  .AND.  kk == 1 )          &
                 READ ( 13 )  surf_v(2)%pt_surface
-          CASE ( 'surf_v(2)%q_surface' )         
+          CASE ( 'surf_v(2)%q_surface' )
              IF ( ALLOCATED( surf_v(2)%q_surface )  .AND.  kk == 1 )           &
                 READ ( 13 )  surf_v(2)%q_surface
-          CASE ( 'surf_v(2)%vpt_surface' )         
+          CASE ( 'surf_v(2)%vpt_surface' )
              IF ( ALLOCATED( surf_v(2)%vpt_surface )  .AND.  kk == 1 )         &
                 READ ( 13 )  surf_v(2)%vpt_surface
-          CASE ( 'surf_v(2)%shf' )         
+          CASE ( 'surf_v(2)%shf' )
              IF ( ALLOCATED( surf_v(2)%shf )  .AND.  kk == 1 )                 &
                 READ ( 13 )  surf_v(2)%shf
-          CASE ( 'surf_v(2)%qsws' )         
+          CASE ( 'surf_v(2)%qsws' )
              IF ( ALLOCATED( surf_v(2)%qsws )  .AND.  kk == 1 )                &
                 READ ( 13 )  surf_v(2)%qsws
-          CASE ( 'surf_v(2)%ssws' )         
+          CASE ( 'surf_v(2)%ssws' )
              IF ( ALLOCATED( surf_v(2)%ssws )  .AND.  kk == 1 )                &
                 READ ( 13 )  surf_v(2)%ssws
-          CASE ( 'surf_v(2)%css' ) 
+          CASE ( 'surf_v(2)%css' )
              IF ( ALLOCATED( surf_v(2)%css )  .AND.  kk == 1 )                 &
                 READ ( 13 )  surf_v(2)%css
-          CASE ( 'surf_v(2)%cssws' )         
+          CASE ( 'surf_v(2)%cssws' )
              IF ( ALLOCATED( surf_v(2)%cssws )  .AND.  kk == 1 )               &
                 READ ( 13 )  surf_v(2)%cssws
-          CASE ( 'surf_v(2)%qcsws' )         
+          CASE ( 'surf_v(2)%qcsws' )
              IF ( ALLOCATED( surf_v(2)%qcsws )  .AND.  kk == 1 )               &
                 READ ( 13 )  surf_v(2)%qcsws
-          CASE ( 'surf_v(2)%ncsws' )         
+          CASE ( 'surf_v(2)%ncsws' )
              IF ( ALLOCATED( surf_v(2)%ncsws )  .AND.  kk == 1 )               &
                 READ ( 13 )  surf_v(2)%ncsws
-          CASE ( 'surf_v(2)%qrsws' )         
+          CASE ( 'surf_v(2)%qisws' )
+             IF ( ALLOCATED( surf_v(2)%qisws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_v(2)%qisws
+          CASE ( 'surf_v(2)%nisws' )
+             IF ( ALLOCATED( surf_v(2)%nisws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_v(2)%nisws
+          CASE ( 'surf_v(2)%qrsws' )
              IF ( ALLOCATED( surf_v(2)%qrsws )  .AND.  kk == 1 )               &
                 READ ( 13 )  surf_v(2)%qrsws
-          CASE ( 'surf_v(2)%nrsws' )         
+          CASE ( 'surf_v(2)%nrsws' )
              IF ( ALLOCATED( surf_v(2)%nrsws )  .AND.  kk == 1 )               &
                 READ ( 13 )  surf_v(2)%nrsws
-          CASE ( 'surf_v(2)%sasws' )         
+          CASE ( 'surf_v(2)%sasws' )
              IF ( ALLOCATED( surf_v(2)%sasws )  .AND.  kk == 1 )               &
                 READ ( 13 )  surf_v(2)%sasws
-          CASE ( 'surf_v(2)%mom_uv' )         
+          CASE ( 'surf_v(2)%mom_uv' )
              IF ( ALLOCATED( surf_v(2)%mom_flux_uv )  .AND.  kk == 1 )         &
                 READ ( 13 )  surf_v(2)%mom_flux_uv
-          CASE ( 'surf_v(2)%mom_w' )         
+          CASE ( 'surf_v(2)%mom_w' )
              IF ( ALLOCATED( surf_v(2)%mom_flux_w )  .AND.  kk == 1 )          &
                 READ ( 13 )  surf_v(2)%mom_flux_w
-          CASE ( 'surf_v(2)%mom_tke' )         
+          CASE ( 'surf_v(2)%mom_tke' )
              IF ( ALLOCATED( surf_v(2)%mom_flux_tke )  .AND.  kk == 1 )        &
                 READ ( 13 )  surf_v(2)%mom_flux_tke
 
-          CASE ( 'surf_v(3)%start_index' )   
+          CASE ( 'surf_v(3)%start_index' )
              IF ( kk == 1 )                                                    &
                 READ ( 13 )  surf_v(3)%start_index
              l = 3
-          CASE ( 'surf_v(3)%end_index' )   
+          CASE ( 'surf_v(3)%end_index' )
              IF ( kk == 1 )                                                    &
                 READ ( 13 )  surf_v(3)%end_index
-          CASE ( 'surf_v(3)%us' )         
+          CASE ( 'surf_v(3)%us' )
              IF ( ALLOCATED( surf_v(3)%us )  .AND.  kk == 1 )                  &
                 READ ( 13 )  surf_v(3)%us
-          CASE ( 'surf_v(3)%ts' )         
+          CASE ( 'surf_v(3)%ts' )
              IF ( ALLOCATED( surf_v(3)%ts )  .AND.  kk == 1 )                  &
                 READ ( 13 )  surf_v(3)%ts
-          CASE ( 'surf_v(3)%qs' )        
+          CASE ( 'surf_v(3)%qs' )
              IF ( ALLOCATED( surf_v(3)%qs )  .AND.  kk == 1 )                  &
                 READ ( 13 )  surf_v(3)%qs
-          CASE ( 'surf_v(3)%ss' )         
+          CASE ( 'surf_v(3)%ss' )
              IF ( ALLOCATED( surf_v(3)%ss )  .AND.  kk == 1 )                  &
                 READ ( 13 )  surf_v(3)%ss
-          CASE ( 'surf_v(3)%qcs' )         
+          CASE ( 'surf_v(3)%qcs' )
              IF ( ALLOCATED( surf_v(3)%qcs )  .AND.  kk == 1 )                 &
                 READ ( 13 )  surf_v(3)%qcs
-          CASE ( 'surf_v(3)%ncs' )         
+          CASE ( 'surf_v(3)%ncs' )
              IF ( ALLOCATED( surf_v(3)%ncs )  .AND.  kk == 1 )                 &
                 READ ( 13 )  surf_v(3)%ncs
-          CASE ( 'surf_v(3)%qrs' )         
+          CASE ( 'surf_v(3)%qis' )
+             IF ( ALLOCATED( surf_v(3)%qis )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_v(3)%qis
+          CASE ( 'surf_v(3)%nis' )
+             IF ( ALLOCATED( surf_v(3)%nis )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_v(3)%nis
+          CASE ( 'surf_v(3)%qrs' )
              IF ( ALLOCATED( surf_v(3)%qrs )  .AND.  kk == 1 )                 &
                 READ ( 13 )  surf_v(3)%qrs
-          CASE ( 'surf_v(3)%nrs' )         
+          CASE ( 'surf_v(3)%nrs' )
              IF ( ALLOCATED( surf_v(3)%nrs )  .AND.  kk == 1 )                 &
                 READ ( 13 )  surf_v(3)%nrs
-          CASE ( 'surf_v(3)%ol' )         
+          CASE ( 'surf_v(3)%ol' )
              IF ( ALLOCATED( surf_v(3)%ol )  .AND.  kk == 1 )                  &
                 READ ( 13 )  surf_v(3)%ol
-          CASE ( 'surf_v(3)%rib' )         
+          CASE ( 'surf_v(3)%rib' )
              IF ( ALLOCATED( surf_v(3)%rib )  .AND.  kk == 1 )                 &
                 READ ( 13 )  surf_v(3)%rib
-          CASE ( 'surf_v(3)%pt_surface' )         
+          CASE ( 'surf_v(3)%pt_surface' )
              IF ( ALLOCATED( surf_v(3)%pt_surface )  .AND.  kk == 1 )          &
                 READ ( 13 )  surf_v(3)%pt_surface
-          CASE ( 'surf_v(3)%q_surface' )         
+          CASE ( 'surf_v(3)%q_surface' )
              IF ( ALLOCATED( surf_v(3)%q_surface )  .AND.  kk == 1 )           &
                 READ ( 13 )  surf_v(3)%q_surface
-          CASE ( 'surf_v(3)%vpt_surface' )         
+          CASE ( 'surf_v(3)%vpt_surface' )
              IF ( ALLOCATED( surf_v(3)%vpt_surface )  .AND.  kk == 1 )         &
                 READ ( 13 )  surf_v(3)%vpt_surface
-          CASE ( 'surf_v(3)%shf' )         
+          CASE ( 'surf_v(3)%shf' )
              IF ( ALLOCATED( surf_v(3)%shf )  .AND.  kk == 1 )                 &
                 READ ( 13 )  surf_v(3)%shf
-          CASE ( 'surf_v(3)%qsws' )         
-             IF ( ALLOCATED( surf_v(3)%qsws )  .AND.  kk == 1 )                & 
+          CASE ( 'surf_v(3)%qsws' )
+             IF ( ALLOCATED( surf_v(3)%qsws )  .AND.  kk == 1 )                &
                 READ ( 13 )  surf_v(3)%qsws
-          CASE ( 'surf_v(3)%ssws' )         
+          CASE ( 'surf_v(3)%ssws' )
              IF ( ALLOCATED( surf_v(3)%ssws )  .AND.  kk == 1 )                &
                 READ ( 13 )  surf_v(3)%ssws
-          CASE ( 'surf_v(3)%css' ) 
+          CASE ( 'surf_v(3)%css' )
              IF ( ALLOCATED( surf_v(3)%css )  .AND.  kk == 1 )                 &
                 READ ( 13 )  surf_v(3)%css
-          CASE ( 'surf_v(3)%cssws' )         
+          CASE ( 'surf_v(3)%cssws' )
              IF ( ALLOCATED( surf_v(3)%cssws )  .AND.  kk == 1 )               &
                 READ ( 13 )  surf_v(3)%cssws
-          CASE ( 'surf_v(3)%qcsws' )         
+          CASE ( 'surf_v(3)%qcsws' )
              IF ( ALLOCATED( surf_v(3)%qcsws )  .AND.  kk == 1 )               &
                 READ ( 13 )  surf_v(3)%qcsws
-          CASE ( 'surf_v(3)%ncsws' )         
+          CASE ( 'surf_v(3)%ncsws' )
              IF ( ALLOCATED( surf_v(3)%ncsws )  .AND.  kk == 1 )               &
                 READ ( 13 )  surf_v(3)%ncsws
-          CASE ( 'surf_v(3)%qrsws' )         
+          CASE ( 'surf_v(3)%qisws' )
+             IF ( ALLOCATED( surf_v(3)%qisws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_v(3)%qisws
+          CASE ( 'surf_v(3)%nisws' )
+             IF ( ALLOCATED( surf_v(3)%nisws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_v(3)%nisws
+          CASE ( 'surf_v(3)%qrsws' )
              IF ( ALLOCATED( surf_v(3)%qrsws )  .AND.  kk == 1 )               &
                 READ ( 13 )  surf_v(3)%qrsws
-          CASE ( 'surf_v(3)%nrsws' )         
+          CASE ( 'surf_v(3)%nrsws' )
              IF ( ALLOCATED( surf_v(3)%nrsws )  .AND.  kk == 1 )               &
                 READ ( 13 )  surf_v(3)%nrsws
-          CASE ( 'surf_v(3)%sasws' )         
+          CASE ( 'surf_v(3)%sasws' )
              IF ( ALLOCATED( surf_v(3)%sasws )  .AND.  kk == 1 )               &
                 READ ( 13 )  surf_v(3)%sasws
-          CASE ( 'surf_v(3)%mom_uv' )         
+          CASE ( 'surf_v(3)%mom_uv' )
              IF ( ALLOCATED( surf_v(3)%mom_flux_uv )  .AND.  kk == 1 )         &
                 READ ( 13 )  surf_v(3)%mom_flux_uv
-          CASE ( 'surf_v(3)%mom_w' )         
+          CASE ( 'surf_v(3)%mom_w' )
              IF ( ALLOCATED( surf_v(3)%mom_flux_w )  .AND.  kk == 1 )          &
                 READ ( 13 )  surf_v(3)%mom_flux_w
-          CASE ( 'surf_v(3)%mom_tke' )         
+          CASE ( 'surf_v(3)%mom_tke' )
              IF ( ALLOCATED( surf_v(3)%mom_flux_tke )  .AND.  kk == 1 )        &
                 READ ( 13 )  surf_v(3)%mom_flux_tke
@@ -4763,10 +5042,10 @@
        END SELECT
 !
-!--    Redistribute surface elements on its respective type. Start with 
+!--    Redistribute surface elements on its respective type. Start with
 !--    horizontally orientated surfaces.
        IF ( horizontal_surface  .AND.                                          &
             .NOT. INDEX( restart_string(1:length), '%start_index' ) /= 0 )     &
        THEN
-       
+
           ic = nxlc
           DO  i = nxlf, nxrf
@@ -4774,19 +5053,19 @@
              DO  j = nysf, nynf
 !
-!--             Determine type of surface element, i.e. default, natural, 
-!--             urban, at current grid point. 
+!--             Determine type of surface element, i.e. default, natural,
+!--             urban, at current grid point.
                 surf_match_def  = surf_def_h(l)%end_index(jc,ic) >=            &
                                   surf_def_h(l)%start_index(jc,ic)
                 surf_match_lsm  = ( surf_lsm_h%end_index(jc,ic)  >=            &
                                     surf_lsm_h%start_index(jc,ic) )            &
-                             .AND.  l == 0 
+                             .AND.  l == 0
                 surf_match_usm  = ( surf_usm_h%end_index(jc,ic)  >=            &
                                     surf_usm_h%start_index(jc,ic) )            &
-                             .AND.  l == 0 
+                             .AND.  l == 0
 !
 !--             Write restart data onto default-type surfaces if required.
                 IF ( surf_match_def )  THEN
 !
-!--                Set the start index for the local surface element 
+!--                Set the start index for the local surface element
                    mm = surf_def_h(l)%start_index(jc,ic)
 !
@@ -4794,5 +5073,5 @@
 !--                and in case the local surface element mm is smaller than
 !--                the local end index, assign the respective surface data
-!--                to this element. 
+!--                to this element.
                    DO  m = surf_h(l)%start_index(j,i),                         &
                            surf_h(l)%end_index(j,i)
@@ -4805,7 +5084,7 @@
 !
 !--             Same for natural-type surfaces. Please note, it is implicitly
-!--             assumed that natural surface elements are below urban 
+!--             assumed that natural surface elements are below urban
 !--             urban surface elements if there are several horizontal surfaces
-!--             at (j,i). An example would be bridges. 
+!--             at (j,i). An example would be bridges.
                 IF ( surf_match_lsm )  THEN
                    mm = surf_lsm_h%start_index(jc,ic)
@@ -4843,6 +5122,6 @@
              DO  j = nysf, nynf
 !
-!--             Determine type of surface element, i.e. default, natural, 
-!--             urban, at current grid point. 
+!--             Determine type of surface element, i.e. default, natural,
+!--             urban, at current grid point.
                 surf_match_def  = surf_def_v(l)%end_index(jc,ic) >=            &
                                   surf_def_v(l)%start_index(jc,ic)
@@ -4852,8 +5131,8 @@
                                   surf_usm_v(l)%start_index(jc,ic)
 !
-!--             Write restart data onto default-type surfaces if required.               
+!--             Write restart data onto default-type surfaces if required.
                 IF ( surf_match_def )  THEN
 !
-!--                Set the start index for the local surface element 
+!--                Set the start index for the local surface element
                    mm = surf_def_v(l)%start_index(jc,ic)
 !
@@ -4861,5 +5140,5 @@
 !--                and in case the local surface element mm is smaller than
 !--                the local end index, assign the respective surface data
-!--                to this element. 
+!--                to this element.
                    DO  m = surf_v(l)%start_index(j,i),                         &
                            surf_v(l)%end_index(j,i)
@@ -4872,10 +5151,10 @@
 !
 !--             Same for natural-type surfaces. Please note, it is implicitly
-!--             assumed that natural surface elements are below urban 
+!--             assumed that natural surface elements are below urban
 !--             urban surface elements if there are several vertical surfaces
-!--             at (j,i). An example a terrain elevations with a building on 
+!--             at (j,i). An example a terrain elevations with a building on
 !--             top. So far, initialization of urban surfaces below natural
 !--             surfaces on the same (j,i) is not possible, so that this case
-!--             cannot occur. 
+!--             cannot occur.
                 IF ( surf_match_lsm )  THEN
                    mm = surf_lsm_v(l)%start_index(jc,ic)
@@ -4918,5 +5197,5 @@
              IMPLICIT NONE
 
-             INTEGER(iwp)      ::  m_file      !< respective surface-element index of current surface array 
+             INTEGER(iwp)      ::  m_file      !< respective surface-element index of current surface array
              INTEGER(iwp)      ::  m_target    !< respecitve surface-element index of surface array on file
              INTEGER(iwp)      ::  lsp         !< running index chemical species
